CONST
 XORTable :Array[0..63] of byte = (136,168,143,186,138,211,185,245,237,177,
                                   207,234,170,228,181,251,235,130,249,144,
                                   202,201,181,231,220,142,183,172,238,247,
                                   224,202,142,234,202,128,206,197,173,183,
                                   196,208,132,147,213,240,235,200,180,157,
                                   204,175,165,149,186,153,135,210,157,227,
                                   145,186,144,202);

TYPE
 TChunkID = Array[0..7] of Char;

 TBIFHeader = Packed Record
  BIFMarker       :TChunkID; { BIFFV1<space><space> }
  CatEntries      :LongInt;
  CatMMEntries    :LongInt;
  CatOffset       :LongInt;
 end;

 TBIFCatEntry = Packed Record
  ResIdx          :Word;
  unknown1        :Word;
  Offset          :LongInt;
  Size            :LongInt;
  ChunkType       :LongInt;
 end;

 TKEYHeader = Packed Record
  Marker         :Array[0..7] of Char;
  ResFileEntries :LongInt;
  ResEntries     :LongInt;
  FileTblOffs    :LongInt;
  ResTblOffs     :LongInt;
 end;

 TKEYResFileEntry = Packed Record
  Size          :LongInt;
  FilenameOffs  :LongInt;
  FilenameLen   :Word;
  CDmap         :Word;
 end;

 TKEYResourceEntry = Packed Record
  Identifier    :Array[0..7] of Char;
  ResType       :Word;
  unknown1      :Word;
  unknown2      :Word;
 end;

 TTLKHeader = Packed Record
  Marker        :Array[1..8] of Char;
  unknownW1     :Word;
  CatEntries    :LongInt;
  DataOfs       :LongInt;
 end;

 TTLKEntry = Packed Record
  ResType       :Word;
  ResName       :Array[1..8] of Char;
  unknown1      :LongInt;
  unknown2      :LongInt;
  ResOffs       :LongInt;
  ResSize       :LongInt;
 end;

 TITMHeader = Packed Record
  Marker          :TChunkID; { ITM V1 }
  DescPTR1,
  DescPTR2        :LongInt;

  DescPTR3        :LongInt;
  DescPTR4        :LongInt;
(*
  WeaponID        :Array[0..1] of Char;
  Price           :LongInt;
  MaxInStack      :Word;
  Weight          :LongInt;
  DescPTR3        :LongInt;
  WeaponEntryPtr1,           { relative }
  WeaponEntryCnt1,
  WeaponEntryPtr2,
  WeaponEntryCnt2 :Word; *)
 end;

 TBAMHeader = Packed Record
  Marker        :TChunkID;
  FrameCnt,
  FrameCnt2     :Word;
  FrameHdrPtr   :LongInt;
  PalettePtr    :LongInt;
  FrameIDPtr    :LongInt;
 end;

 TBAMFrameHeader = Packed Record
  Width           :Word;
  Height          :Word;
  COG1,COG2       :Integer; { 2 bytes each! }
  GraphicsPtr     :LongInt;
 end;

 TPal1 = Packed Record
  R,G,B,A :Byte;
 end;
 TPalette = Packed Array[0..255] of TPal1;

 TPal2 = Packed Record
  R,G,B   :Byte;
 end;
